using GraphicsManager.Enums;
using GraphicsManager.Interfaces;
using GraphicsManager.Objects;
using GraphicsManager.Objects.Core;
using Luski.GUI.MainScreen.Interfaces;
using Luski.GUI.Windows;
using Luski.net.JsonTypes;
using OpenTK.Graphics.OpenGL4;
using OpenTK.Mathematics;
using OpenTK.Windowing.Common;
using OpenTK.Windowing.Desktop;
using OpenTK.Windowing.GraphicsLibraryFramework;
using Window = GraphicsManager.Window;

namespace Luski.GUI.MainScreen.UI;

public class Friend : UserControl, IChannelPick
{
    public SocketRemoteUser User;

    public SocketTextChannel Channel
    {
        get
        {
            return User.Channel;
        }
    }
    private Rectangle r;
    public Label Username, Status;
    public Friend(SocketRemoteUser person)
    {
        User = person;
        Size = new((int)(185 * Globals.Settings.Scale), (int)(48* Globals.Settings.Scale));
        BackgroundColor = new(34, 34, 34, 255);
        Controls.Add( r = new Rectangle(Globals.ms.TextureManager.AddTexture(person.GetAvatar(CancellationToken.None).Result, true)) { Location = new((int)(7.5 * Globals.Settings.Scale),(int)(8.5 * Globals.Settings.Scale)), Size = new((int)(29* Globals.Settings.Scale))});
        Controls.Add(Username = new Label() { Font = Globals.DefaultFont, Text = person.Username, Location = new((int)(38.5 * Globals.Settings.Scale),(int)(10 * Globals.Settings.Scale))});
        Controls.Add(Status = new Label() { Font = Globals.DefaultFont, Text = person.Status.ToString(), Location = new((int)(38.5 * Globals.Settings.Scale),(int)(24 * Globals.Settings.Scale))});
        this.Clicked += AllOnClicked;
        ContextMenu = new((int)(150 * Globals.Settings.Scale));
        RoundedButton rr, rr2;
        ContextMenu.Items.Add(rr=new()
        {
            InsideColor = new(28, 28, 28, 255), BorderColor = Color4.DarkCyan,
            Size = new((int)(25 * Globals.Settings.Scale)), Font = Globals.DefaultFont, Text = "Export Keys"
        });
        ContextMenu.Items.Add(rr2=new()
        {
            InsideColor = new(28, 28, 28, 255), BorderColor = Color4.DarkCyan,
            Size = new((int)(25 * Globals.Settings.Scale)), Font = Globals.DefaultFont, Text = "Open In New Window"
        });
        rr2.Clicked += Rr2OnClicked;
        rr.Clicked += RrOnClicked;
    }

    private Task Rr2OnClicked(IRenderObject arg)
    {
        GLFW.WindowHint(WindowHintBool.Decorated, false);
        ChatWindow w = new(this);
        
        //w.WindowBorder = WindowBorder.Resizable;
       // ContextMenu!.HideContext(Window!);
        //Window!.DrawFrame();
        w.StartRender();
        //w.IsEventDriven = true;
        //Window.Windows.Add(w);
        //w.StartRenderAsync();
        //w.StartRender();
        //ContextMenu!.HideContext(Window!);
        return Task.CompletedTask;
    }

  

    private Task RrOnClicked(IRenderObject arg)
    {
        _ = User.Channel!.SendKeysToUsers(CancellationToken.None);
        ContextMenu!.HideContext(Window!);
        return Task.CompletedTask;
    }

    private Task AllOnClicked(IRenderObject arg)
    {
        if (ClickCon is not null) _ = ClickCon.Invoke(this);
        return Task.CompletedTask;
    }

    public event Func<IChannelPick, Task>? ClickCon;
}